
#include <SPI.h>
#include <WiFi.h>

#include <FreeSixIMU.h>
#include <FIMU_ADXL345.h>
#include <FIMU_ITG3200.h>

#include <Wire.h>

#include <UbidotsArduino.h>
#define ID1  "5750880b76254249af3d61a5"  // Put here your Ubidots variable ID
#define ID2  "5750897b762542594b9ce635"  // Put here your Ubidots variable ID
#define ID3  "575089857625425a30fa260f"  // Put here your Ubidots variable ID
#define ID4  "5750898d7625425a563a7e93"  // Put here your Ubidots variable ID
#define ID5  "575089977625425a1198ec5e"  // Put here your Ubidots variable ID
#define ID6  "5750899c7625425ac3d02e45"  // Put here your Ubidots variable ID
#define TOKEN  "bkcZclmWo2CM1JiUYxAvzyMakeT1Kk"  // Put here your Ubidots TOKEN


char ssid[] = "Bhukkad Ave"; //  your network SSID (name)
char pass[] = "kamliboys";    // your network password (use for WPA, or use as key for WEP)
int keyIndex = 0;            // your network key Index number (needed only for WEP)

int status = WL_IDLE_STATUS;

Ubidots client(TOKEN);

float angles[3]; // yaw pitch roll
float acc[3];
float actAcc[3];
float prevAcc[3];
//byte range;

// Set the FreeSixIMU object
FreeSixIMU sixDOF = FreeSixIMU();
//adxl = ADXL345();

//ANALOG PINS
#define SCL 5
#define SDA 4

void setup(){
    Serial.begin(9600);
    while (!Serial) {
        ; // wait for serial port to connect. Needed for native USB port only
    }

    // check for the presence of the shield:
    if (WiFi.status() == WL_NO_SHIELD) {
        Serial.println("WiFi shield not present");
        // don't continue:
        while (true);
    }

    String fv = WiFi.firmwareVersion();
    if (fv != "1.1.0") {
        Serial.println("Please upgrade the firmware");
    }

    // attempt to connect to Wifi network:
    while (status != WL_CONNECTED) {
        Serial.print("Attempting to connect to SSID: ");
        Serial.println(ssid);
        // Connect to WPA/WPA2 network. Change this line if using open or WEP network:
        status = WiFi.begin(ssid, pass);

        // wait 10 seconds for connection:
        delay(10000);
    }
    Wire.begin();
  
    delay(5);
    sixDOF.init(); //begin the IMU
    delay(5);
    prevAcc[0]=0;
    prevAcc[1]=0;
    prevAcc[2]=0;
    //  sixDOF.getRangeSetting(4);
        
}
void loop()
{
  sixDOF.getEuler(angles);
  sixDOF.getValues(acc);
  actAcc[0]=(prevAcc[0]-acc[0])*0.0078125;
  actAcc[1]=(prevAcc[1]-acc[1])*0.0078125; 
  actAcc[2]=(prevAcc[2]-acc[2])*0.0078125;

  float value1 = angles[0];
  float value2 = angles[1];
  float value3 = angles[2];
  float value4 = actAcc[0];
  float value5 = actAcc[1];
  float value6 = actAcc[2];

  Serial.print(angles[2]);
  Serial.print(" | ");  
  Serial.print(angles[1]);
  Serial.print(" | ");
  Serial.print(angles[0]);

  client.add(ID1,value1);
  client.add(ID2,value2);
//  client.add(ID3,value3);
//  client.add(ID4,value4);
//  client.add(ID5,value5);
//  client.add(ID6,value6);
  client.sendAll();
  
  prevAcc[0]=acc[0];
  prevAcc[1]=acc[1];
  prevAcc[2]=acc[2];
  delay(1000); 
}
